;---------------------------------------------------------
;- Hermit Relocator - targeted for music (64tass syntax) -
;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------------------------------------------------
;SOME RESTRICTIONS!!
;-------------------
;-Sorce and target regions must be between $1000...$ffff ($0800-$0fff is taken by this program)
;-DO NOT USE ZEROPAGE ($00-$FF) FOR SOURCE/TARGET RANGE!
;-Overlapping not allowed between source and destination regions (in this case double relocation would be solution)
   ;(-and TARGET range SHOULD BE FURTHER THAN $0100 RELATIVE TO SOURCE-range!)
   ;(-IF PROGRAM COPIES ITS CODE-PARTS TO OTHER LOCATIONS (rare), YOU MAY NEED TO RESPECIFY the RANGE!)
;-NO ILLEGAL OPCODE SUPPORT YET!! (THEY'RE ALL $ff IN THE command-table)
;-Relocate tune that's not including SEI,CLI,FFFF,FFFE and DC04/DC05/DC0D/DC0E setting (later these commands will be ignored)
   ;(-if the tune starts with CIA/raster-irq setting, find the 'normal' entry points for init/play)
;---------------------------------------------------------------------------------------------------

;---------------------------------------------------------------------------------------------------
;here you are including the tune (prg native C64 format,to be relocated) into the source-code:

*=$A400
tunestart
.binary "parallax(4)-bfc0-bfe0.prg",2
tuneend

;-------------------------------------------------------------------------------------
;Here you give the parameters, for this source-code (like startaddress,endaddress,etc.)

rstart=tunestart  ;original startaddress, start(hi) of the area to relocate
rend=tuneend      ;end of the area to relocate

initaccu=3        ;the player will be initialized with this accu (subtune-sign)
initaddr=$bfc0    ;entry point for init (original init-address)
playaddr=$bfe0    ;entry point for play (original play-address)

newaddr=$1000     ;the new (wished) base-address (beginning of target-range)

maskrel=0       ;0=start with mask maker function, 1=start with relocator function, 2-start with finder
swdisp=0        ;0=no display - faster , 1=display on - slower

follow=0        ;0=stopping-key,1=stepping-key,2-continuing-key
cleart=1        ;1=clear target before start, 0=no clear (0 not recommended!)
clear0=1        ;1=don't copy unused places to target at relocating (unused remains 0), 0= copy unused places also


;--------------------------------------------------------------
BASICSYS   ;BASIC row with SYS to program-start (you can cut this if will run compiled Reloc-aid from monitor with 'G 0810')

		*=$0801
		.word ss,2005
		.null $9e,^2064 ;Sys 2064 ($0810)
ss		.word 0


;------------------------------------------------------------------
;Jump table for compiled binary version of Reloc-aid -
;-----------------------------------------------------
        *= $0810
        jmp init      ;$0810 jumps to all-start, the 'maskrel' byte decides, which function (maskmaker/reloc/finder) is called
        
        jmp maskmaker ;$0813 directly jumps to PASS1 - maskmaker
        jmp goreloc   ;$0816 directly jumps to PASS2 - relocator (exchanges source-range & target(mask))
        jmp gofinder  ;$0819 directly jumps to PASS3 - pointer-finder, that stops at every read/write that still addresses into source-range

		jmp swapaddr  ;$081C directly jumps to source/target addresses swapper/changer (exchanges them)
                      ;then goes to 'gofinder'

;---------------------------------------------------------------------------------------
;DATAbytes for IO (binary version of Reloc-aid can be controlled through this)
;-------------------------------------------------------------------------
stadd .byte <rstart,>rstart     ;$081F - Startaddress of source-region (to relocate)
endad .byte <rend,>rend         ;$0821 - End-address of source-region (to relocate)

iniac .byte initaccu            ;$0823 - Subtune value for accumulator before init-tune
iniad .byte <initaddr,>initaddr ;$0824 - Init-address of tune
plyad .byte <playaddr,>playaddr ;$0826 - Playroutine-address (usually called on each frame)

newad .byte <newaddr,>newaddr   ;$0828 - The wished base-address for the target-location (relocates here)

mskrl .byte maskrel  ;$082A - if 0/1/2, Reloc-aid starts with maskmaker/relocator/finder/tester function
swdis .byte swdisp   ;$082B - if 0, display turned off (recommended default)

follw .byte follow   ;$082C - if 0..2, continuous/stepping modes, 3:finder (stops at wrong outside-call)
clrtg .byte cleart   ;$082D - if 1, clears the target (highly recommended)
clrun .byte clear0   ;$082E - if 1, doesn't copy unused code/data to target (recommended)



;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
maskmaker     ;the entry point of maskmaker (PASS1), mask will be made here
		lda #0
		beq setmflg

goreloc lda #1
		bne setmflg

gofinder        ;the entry point of finder, which uses the same routine, but stops on outside calls
		lda #2  ;the source-addresses and target-addresses were changed/swapped before in relocator (PASS2)

setmflg	sta mskrl ;set 'maskrel' mode-selection flag and start program
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
init    sei       ;disable IRQ for CPU during initialization
        lda #$35
        sta 1     ;switch to RAM at BASIC and KERNAL area
        lda #3
        sta $dd00 ;video bank is the 1st ($0000..$3fff)
        lda #0
        sta endmsk ;init end-maskmaker signal
        sta outrange 
        sta $d015 ;prevent sprite-heyching lost cycles
        sta $d01a ;disable Raster-IRQ
        sta $dc05 ;zero down CIA-counter hi-value
        sta $d020 ;border colour black
        sta $d021 ;background colour balck
        lda #$1b
        sta $d011 ;switch on display
        lda #$16
        sta $d018 ;small character-set
        
        JSR SCRINIT ;delete screen
        
        lda mskrl    ;the decision point, what to do (maskmaker/relocator/finder)
        cmp #1
        bne maskmak  ;maskmaker / finder mode (mode 0/2)
		jmp relocer  ;relocator (mode 1)

maskmak
		jsr initnew ;init new area
		
        ldx #$1b
        lda swdis
        bne scron
        ldx #$0b
scron   stx $d011 ;switch on normal (default mode) screen
        asl $d019 ;clear possible raster-interrupt-sign flag
        lda #$7f
        sta $dc0d ;disable CIA1 interrupts
        sta $dd0d ;disable CIA2 interrupts
        lda $dc0d ;clear CIA1 possible IRQ-sign flags
        lda $dd0d ;clear CIA2 possible IRQ-sign flags
        lda #<irq
        sta $fffe ;set IRQ address (low)
        lda #>irq
        sta $ffff ;set IRQ address (high)
        
        ldx #1
jsrplp  lda iniad,x
        sta initune+1,x ;set JSR-entry point address
        lda plyad,x
		sta plytune+1,x ;set playroutine jsr-address
		dex
		bpl jsrplp
		
        lda #2    ;cli,first command executes,then IRQ
        sta $dc04 ;set CIA timer to do IRQ during CLI        
		lda #$10
		sta $dc0e ;stop CIA1-TimerA;$DC04 forced set
        lda #$81
        sta $dc0d ;enable CIA1-TimerA interrupt
        lda #$ff
        cmp $d012 ;prevent badlines for cyclecounting
        bne *-3
        lda #$0f
        sta $d418 ;Volume fix was needed for Parallax, maybe also for other tunes
        lda iniac ;accu for subtune
        ;sta stadd ;this was needed for tusker ($e000 holds subtune number)
        ;ldy #0    ;Y can be initialized here in case
        ldx #$19  
        stx $dc0e ;start oneshot CIA1-TimerA
        cli       ;enable interrupts for CPU, 2 cycles spent

initune	jsr $0000 ;call init routne, operand will be overwritten by init-address
plytune jsr $0000 ;call playroutine, operand will be overwritten by play-address
		lda endmsk
		beq plytune ;repeat playing routine until STOP was pressed (and endmask other than 0)

;--------------------------------------------------------------------------------------------
zpmask  sei ;switch off IRQ, completing the mask with used zeropage-modifiers
		            ;finds, which zeropage-writer commands affects used zp-pointer
                    ;and signs the pointers with "$0c $0d" and modifiers (STA,...) with "$0e"
		ldx #1
ptslp	lda stadd,x
		sta $fc,x    
		lda newad,x
		sta $fe,x
		dex
		bpl ptslp

		lda mskrl   ;prevent writing mask, if we are in finder mode
		bne relocer

		ldx #0  ; X will be the pointer for the zp-pointer table
		stx 4
		ldy #0
zcklp	lda ($fe),y
		cmp #$03
		bne nozptr
		lda ($fc),y
		stx 2
cmpzp	cmp $07c0,x ;!!! search, if exists already
		beq loadx ;if exists, don't write into zp-table
		dex
		bpl cmpzp
		sty 3     ;the pointer doesn't exist in table yet
		ldx 2
		sta $07c0,x  ;we poke it into zp-table
		jsr hex
		txa
		ldx 4
		sta $0450,x ;and show this on screen
		tya
		sta $0451,x
		inc 4
		inc 4
		inc 4
		ldy 3
		inc 2
loadx	ldx 2    ;2 stores the actual zppointer-table pointer
nozptr	iny
		bne zcklp
		lda $fd
		cmp endad+1
		beq endzck
		inc $fd
		inc $ff
		jmp zcklp
endzck	             ;here we search (backwards) the used zeropage-pointer modifier STA/STX/STY commands
zpmlp	lda ($fe),y
		cmp #$0c   ;check if this is a zp-modifier STA/STX/STY
		bne nozpmod
		iny        ;it is zp-modifire, now check, if it modifies an used zp-pointer
		lda ($fc),y ;get the operand of the zp-modifier command
		dey
		ldx 2       ;start searching in zppointer-table
zpmclp	cmp $07c0,x
		beq signzpm
		dex
		bpl zpmclp
		jmp nozpmod ;was not found, so not writing, just search towards
signzpm lda #$0e    ;this is the new sign to mask
		sta ($fe),y ;sign the zp-modifier STA/STX/STY which modifies used zp-pointer
nozpmod iny
		bne zpmlp
		lda $ff
		cmp newad+1
		beq relocer
		dec $fd
		dec $ff
		jmp zpmlp

;-------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------------
relocer              ;PASS2-relocator part, it uses the premade mask from PASS1
		jsr scrnon   ;switch on screen
		ldy #$0e
SIDCLP	LDA #0
		sta $d404,y  ;mute SID ($d404+..$d40b..+$d412) and write prompt
		LDA reltxt,y
		sta $0608,y
		dey
		bpl sidclp

		jsr waitspc  ;wait for SPACE pressing

		jsr diffcal  ;calculate rdiff (the difference between old & new address)
		ldx #1
ptslp2	lda stadd,x
		sta $fc,x     ;setting source pointers
		lda newad,x
		sta $fe,x     ;setting target pointers
		dex
		bpl ptslp2
		
rlclp	ldy #0      ;y will be 0, only pointers increment to prevent boundary-problems
		lda ($fe),y
		sta mskbck+1  ;if this row pulled off, the source will be 0 for other than 2 value
		sta mskbck2+1 ;if this row pulled off, the source will be 0 for 2 value (1st byte)
		bne usedspc ;if 0, just increment pointers to go next byte, not writing over 0 (empty)
		ldx clrun   ;if clrun=1, then not writing target (unused space remains 0)
		bne mskbck  ;else behave as normal way with unused, copy source to target
usedspc	cmp #2
		beq abschng ;if 2, change the absolute address (2 bytes in lo-hi order)
		
		lda ($fc),y ;if other code-byte or basic data-byte, don't change
		sta ($fe),y ;just write it to target
mskbck	lda #0
		sta ($fc),y ;write mask back to source

iptrs	jsr incptrs  ;increment pointers & check end
		sec        ;we are checking if the source-pointer exceeded endaddress or not
		lda endad
		sbc $fc
		lda endad+1
		sbc $fd
		bcc endrlc ;if over, go to change the source & target addresses for finder
		jmp rlclp    ;if not reacjed endaddress, just go back reading/writing next byte

abschng          ;adding difference to source-abs-pointer, write it to traget-ptr
		ldy #0
		clc
		lda ($fc),y
		adc rdiff
		sta ($fe),y
mskbck2	lda #0
		sta ($fc),y  ;purge source range
		ldy #1
		lda ($fe),y
		sta mskbck3+1  ;if this row pulled off, the source will be 0-ed, else mask written back
		lda ($fc),y
		adc rdiff+1
		sta ($fe),y
mskbck3	lda #0
		sta ($fc),y  ;purge source range
		jsr incptrs
		jmp iptrs

;-----------------------------------------
incptrs	clc
		lda $fc     ;increment pointers by 1
		adc #1
		sta $fc     ;we are incrementing 16bit source-pointer by 1
		lda #0
		adc $fd
		sta $fd
		clc
		lda $fe
		adc #1
		sta $fe     ;we are incrementing 16bit target-pointer by 1
		lda #0
		adc $ff
		sta $ff
		rts

endrlc  ldx #4
fintxlp	lda findtx,x
		sta $060e,x
		dex
		bpl fintxlp

		jsr waitspc  ;waits to PRESS SPACE, then goes to swappaddress, then finder
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
swapaddr
        jsr diffcal  ;calculate new difference
		clc          ;calculate new init & play addresses, store them into themselves (exchange)
		lda rdiff
		adc iniad
		sta iniad    ;new init-address
		lda rdiff+1
		adc iniad+1
		sta iniad+1
		clc
		lda rdiff
		adc plyad
		sta plyad    ;new play-address
		lda rdiff+1
		adc plyad+1
		sta plyad+1
		clc          ;calculate the new source-region end-address
		lda rdiff
		adc endad
		sta endad
		lda rdiff+1
		adc endad+1
		sta endad+1

		lda stadd   ;swapping source & target base-addresses
		ldy newad
		sta newad
		sty stadd
		lda stadd+1
		ldy newad+1
		sta newad+1
		sty stadd+1

		jmp gofinder



;------------------------------------------------------------------
;------------------------------------------------------------------
irq     ;recognises the code (especially addressing mode) after breaking each commands of tune

		sta astore+1 ;store A , with this way, stack won't be touched
		stx xstore+1 ;store X
		sty ystore+1 ;store Y
		bit $dc0d      ;clear IRQ-happened-flag bits in CIA1

		pla            ;get the P (status) register before IRQ
		sta storeP+1
		pla            ;get the lo-address of next instruction after RTI
		sta prgcnt+1
		pla            ;get the hi-address of next instruction after RTI
		sta prgcnt+2
		pha            ;put PC-hi back to stack
		lda prgcnt+1
		pha            ;put PC-lo back to stack
storeP  lda #0
		pha            ;put P (status) register back to stack

		ldy #2         ;read the coming opcode and operands (max 3 bytes)
codlp	jsr coderead
		sta cmdstore,y ;and store them
		dey
		bpl codlp

		jsr display  ;display PC,command,operands,registers on screen
		jsr targetwr ;reading source, writing target mask: codes & changed abs-addr & used data

nooutr	jsr waitkey  ;waits for pressing/releasing SPACE, and checks finder outrange+stops if needed

		lda swdis
		beq ciaset
		lda #$ff
		cmp $d012 ;prevent cycle-counting on badlines
		bne *-3
ciaset	lda #2 + 6 ;6 = added cycles after $dc0e setting till rti
		sta $dc04 ;set timer to allow only 1 command after RTI
		lda #$19
		sta $dc0e ;start oneshot timer, allow one command (min 2 cycles)
		
astore	lda #0    ;restore A , 2 cycles
xstore	ldx #0    ;restore X , 2 cycles
ystore	ldy #0    ;restore Y , 2 cycles
		rti       ;quir from IRQ, 6 cycles, pulls P,PCH,PCL from Stack
		

;------------------------------------------------------------------------
;------------------------------------------------------------------------
;PASS1 ;write modifying-mask into target area
;mask: 0:will be left at moving, no used code/data here (shrinked parts)

;command/operand bytes (section 1.)
;      1-code/operand byte, that we'll never modify
;      2-absolute operand-bytes pointing into source range, always modify!
;      3-..(indirect operand pointing into source range, make jsr?)
;      4-..operand of immediate addressing command, maybe modified if affects indirect 0pg-pointer

;      5-absolute addressing command-byte, don't modify
;      6-..command-byte for indirect addressing (point 3) , don't modify
;      7-..immediate addressing command-byte , don't modify

;data-bytes
;      8-absolute/absX/absY/indirect addresed databyte, don't modify
;      9-zeropage-indirect X/Y indexed databyte,don't modify
;      a-..(pointer-hi databyte, modify)
;      b-..(pointer-lo databyte, modify)

;command/operand bytes (section 2.)
;      c-zeropage writer command ('L')
;      d-operand of zp-writer command ('M')
;      e-zp-pointer modifier STA/STX/STY ('N')
;      f-self writing code (operand modifier (absolute addressing) command)
;--------------------------------------------------------------------------
targetwr    ;first check if PC ins source range, not modifying own callers
		sec      ;check whether actual program counter is >=startaddress
		lda prgcnt+1
		sbc stadd
		lda prgcnt+2
		sbc stadd+1
		bcc skip   ;if smaller, then go to skip
		sec      ;check whether actual program counter is <=endaddress
		lda endad
		sbc prgcnt+1
		lda endad+1
		sbc prgcnt+2
		bcc skip   ;if larger, then got to skip

settarg clc         ;set the target-pointer what will hold command/data info
		lda prgcnt+1
		adc rdiff
		sta writeto+1
		lda prgcnt+2
		adc rdiff+1
		sta writeto+2

		ldy cmdstore ;check actual (next) command
		lda idata,y  ;get adressing mode
		bmi abovec  ;if below $80,write 1 to correspongding mask-address
		lsr
		lsr
		lsr
		lsr
		tax
		ldy clengt,x ;y contains the lenth of the command, (not always) used at filling
		cmp #3
		bmi wr1      ;just 1 (not modify), if addressing mode below 3 (imp/imm/acc)
		cmp #6       ;check if indirect addressing
		bmi zpwrchk  ; check, if zeropage-writer (STA/STX/STY) or zp-indexed writer
		cmp #7
		bne indix
		jmp IndirY

zpwrchk	ldx cmdstore ;using x now, because we need Y as length at 'wr1' if the command isn't zp-writer
		lda idata,x  ;get the zp STA/STX/STY sign from the instruction-table
		and #1       ;check, if it's zp-writer
		beq wr1      ;if no zp-writer sign, jut go to write the 1 (never modity) to the place
		ldy #0
		lda #$0c   ;zp-writer ('L')
		jsr codewrite
		iny
		lda #$0d    ;zp-writer operand-byte ('M')
		jsr codewrite
		rts
		
IndiX	jsr Indirx

wrIndir ldy #1
		lda #3       ;value 3 will filled for indirect addressing commands
		jsr codewrite
		ldy #0
		lda #6
		jsr codewrite
		rts
		
wr1		lda #1        ;not insirect addressing (1..5), writing mask-1 (do not change)
write1  jsr codewrite
		dey
		bpl write1
skip	rts

abovec  cmp #$ff ;above $80,if illegal opcode ($ff), then skip it (later will be processed)
		beq skip
		lsr
		lsr
		lsr
		lsr
		tax
		ldy clengt,x
		cmp #$0c        ;check if Absolute or Indirect addressing
		bmi absol
		jmp notabs
absol	jsr decidabs  ;decide absolute/abs indexed, set chkptr
		sec           ;check if the target address is in the range
		lda chkptr
		sbc stadd
		lda chkptr+1
		sbc stadd+1
		bcc outabs
		sec 
		lda endad
		sbc chkptr
		lda endad+1
		sbc chkptr+1
		bcs setdb1
outabs	lda cmdstore+2
		cmp #$d4
		beq SIDwr  ;if SID-write, outrange dosent't matter for follow-mode 2
		jsr ourg     ;set outrange flag, if we are in follow-mode 2
SIDwr	lda #1       ;if abs-address is outside source range, 1 (nochange-mask)
		jmp wri2   ;? but if the command was signed already as inner, don't overwrite!!!
		
setdb1  clc           ;inside range, set pointers to read&write data-byte at target area
		lda chkptr
		adc rdiff
		sta rfrom+1
		sta dwrto+1
		lda chkptr+1
		adc rdiff+1
		sta rfrom+2
		sta dwrto+2
		ldy #0
		sty selfwr
		jsr cdread    ;read the data-byte from target area
		beq wdatok    ;if there wasn't anything before, then it's a new databyte
		cmp #$0c
		bpl swrer     ;if above c, then addressed target is command/operand, so self-writing code
		cmp #8
		bpl wdatok    ;if between 8..B , then we write new databyte-mask to target
swrer	lda cmdstore  ;from here it was 1..7
		cmp #$4c      ;here is the exception of JMP (not self writing code) 
		beq wdatok
		cmp #$20      ;and this is exception for JSR (not self-writing code)
		beq wdatok
		inc selfwr    ;if 1..7, self-writing code , exception: JMP,JSR,JMP()
		jmp ajjaj     ;go to command-mask writer
		
wdatok	ldx #8
		ldy indiJMP   ;if indirect JMP, sign 2 databytes, else just 1
		beq wrdtmsk
		ldx #2        ; in case of indirect JMP, the databytes now signed as pointers to modify
wrdtmsk	txa
wrdtlp	jsr datamask  ;write the mask (8) to sign absolute-addressed databyte (H)
		dey
		bpl wrdtlp
		
ajjaj	lda #2        ;now we are about writing 2 to command-masks

wri2	ldy #2
		jsr codewrite ;sign abs-address-hi to change at relocation (BB)
		dey
		jsr codewrite ;sign abs address-lo to change at relocation
		ldy #0
		ldx #5        ;and we are signing the absolute command (E)
		lda selfwr
		beq noselfw
		ldx #$0f      ;or sign it as self-writing code - modifier     
noselfw	txa
		jsr codewrite
		rts
		
notabs	cmp #$0c        ;not absolute addressing
		bne skip2       ;check, if immediate addressing, else nothing done (yet)
noskp	ldy #1
		lda #4          ;write immediate operand mask (D)
		jsr codewrite
		ldy #0
		lda #7          ;write immediate command-mask (G)
		jsr codewrite
skip2	rts


;--------------------------------------------------------------------------
IndirY  
		ldy cmdstore+1  ;read zp-address & calculate ind,Y pointer to chkptr
		sty inYstr1+1
		iny
		sty inYstr2+1
inYstr1 lda $00
		sta chkptr
inYstr2 lda $00
		sta chkptr+1
		clc
		lda ystore+1
		adc chkptr
		sta chkptr
		lda #0
		adc chkptr+1
		sta chkptr+1  ;end of ind,Y calculation, chkptr is set
		
		sec           ;check if the Ind,Y  target address is in the range
		lda chkptr
		sbc stadd
		lda chkptr+1
		sbc stadd+1
		bcc outrng
		sec 
		lda endad
		sbc chkptr
		lda endad+1
		sbc chkptr+1
		bcc outrng
		clc           ;inside range, set pointers to read&write data from target area
		lda chkptr
		adc rdiff
		sta rfrom+1
		sta dwrto+1
		lda chkptr+1
		adc rdiff+1
		sta rfrom+2
		sta dwrto+2
		ldy #0
		jsr cdread    ;read the data-byte from target area
		beq wdatok2   ;if there wasn't anything before, then it's a new databyte
		cmp #8
		bpl wdatok2   ;if above 8, then we write new databyte-mask to target
		nop           ;if 1..7, self-writing code , exception: JMP,JSR,JMP()
		jmp outrng
wdatok2	ldy #0
		lda #9
		jsr datamask  ;write the mask (9) to sign data
		jmp wrindir

outrng  jsr ourg
		jmp wrindir  ;if read 0 then set cmd-mask to 1, else (if >0) leave
;---------------------------------------------------------------------------
ourg	lda mskrl  ;check if we selected outcall-stopping follow-mode 2 (finder) 
		cmp #2
		bne nostp
		lda outrange
		bne nostp
		lda #1
		sta outrange
nostp	rts

;-------------------------------------------------------------------
IndirX  
		lda cmdstore+1
		clc
		adc xstore+1
		sta inXstr1+1
		tay
		iny
		sty inXstr2+1
inXstr1 lda $00
		sta chkptr
inXstr2 lda $00
		sta chkptr+1

		sec           ;check if the (Ind,X)  target address is in the range
		lda chkptr
		sbc stadd
		lda chkptr+1
		sbc stadd+1
		bcc outrng2
		sec 
		lda endad
		sbc chkptr
		lda endad+1
		sbc chkptr+1
		bcc outrng2
		clc           ;inside range, set pointers to read&write data from target area
		lda chkptr
		adc rdiff
		sta rfrom+1
		sta dwrto+1
		lda chkptr+1
		adc rdiff+1
		sta rfrom+2
		sta dwrto+2
		ldy #0
		jsr cdread    ;read the data-byte from target area
		beq wdatok3   ;if there wasn't anything before, then it's a new databyte
		cmp #8
		bpl wdatok3   ;if above 8, then we write new databyte-mask to target
		nop           ;if 1..7, self-writing code , exception: JMP,JSR,JMP()
		jmp outrng2
wdatok3	ldy #0
		lda #$0A
		jsr datamask  ;write the mask ($A) to sign data
		          
outrng2	jmp wrindir    ;if read 0 then set cmd-mask to 1, else (if >0) leave

;---------------------------------------------------------------------
decidabs ldx #0          ;decide on absolute or abs-indexed x/y, set chkptr to it
		stx indiJMP
		cmp #8
		bne Absindx
absnorm	lda cmdstore+1
		sta chkptr
		lda cmdstore+2
		sta chkptr+1
		rts
Absindx cmp #9       ;here is the Abs-X address (chkptr) calculator
		bne AbsY
		clc
		lda xstore+1
		adc cmdstore+1
		sta chkptr
		lda #0
		adc cmdstore+2
		sta chkptr+1
		rts
AbsY	cmp #$0b
		beq indJMP   ;and this is the Abs-Y address (chkptr) calculator ($A)
		clc
		lda ystore+1
		adc cmdstore+1
		sta chkptr
		lda #0
		adc cmdstore+2
		sta chkptr+1
		rts
IndJMP  inc indiJMP
		jmp absnorm

;--------------------------------------------------------------------------
;here are the self-written routines for reading data without zeropage-usage

coderead 
prgcnt  lda $0000,y ; the actual PC value, used in IRQ to read actual command+operand
		rts

cdread
rfrom   lda $0000,y ;read the addressed data-byte from source-range
		rts

codewrite
		ldx mskrl  ;write code/operand-sign bytes to mask only in mode 0 (maskmaker)
		bne nowr1
writeto sta $0000,y ;write command-sign into mask at PASS1
nowr1	rts

datamask
		ldx mskrl  ;write databyte-sign to mask only in mode 0 (maskmakre)
		bne nowr2
dwrto   sta $0000,y ;write databyte-sign into mask at PASS1
nowr2	rts

;------------------------------------------------------------
;------------------------------------------------------------
waitkey 
		lda #$7f
		sta $dc00
		lda $dc01
		and #$80   ;check RUNSTOP-key
		bne chkmode
		lda #1     ;if STOP was pressed, then set end to 1
		sta endmsk
		rts

chkmode	lda mskrl  ;if it's mode 2 (finder)
		cmp #2
		bne chkSPC
		lda outrange ;outrange-call stopper
		bmi contp
		beq contp
		and #$80
		sta outrange
		jsr dispnum
		jmp stepp

chkSPC	lda follw
		cmp #1
		bmi contp ;jumps, if 0
		beq stepp ;jumps, if 1

case2	lda #$ff
		cmp $dc01
		beq *-3
		rts

stepp	lda #$ff  ;wait for keypress
		cmp $dc01
		beq *-3
contp	lda swdis
		bne rfromk
		lda #0
		sta $d011
rfromk	lda #$ff  ;wait for key-release
		cmp $dc01
		bne *-3
		rts

waitspc jsr rfromk ;wait for release SPACE
		jmp case2  ;wait for pressing SPACE

;------------------------------------------------------------------
;------------------------------------------------------------------
initnew ;init new area (fill with 0)
		jsr diffcal ;calcucalate 'rdiff' (difference between source & target base-addresses)
		sec         ;calculate length of area to relocate
		lda endad
		sbc stadd
		sta lengt
		lda endad+1
		sbc stadd+1
		sta lengt+1
		tax          ;store length (*256) into X
		
		lda clrtg
		beq rtclr  ;check if we want to clear target area before maskmaking
		lda mskrl
		bne rtclr  ;and only clear mask when we are in maskmaker mode (mode 0)

		lda newad
		sta $fe
		lda newad+1
		sta $ff
		ldy #0     ;init y
		lda #0     ;the value to fill the target area
cllp0	cpx #0     ;pre-test x (length), if not 0
		beq cllp2
cllp1	sta ($fe),y
		iny
		bne cllp1
		inc $ff
		dex
        jmp cllp0
cllp2	sta ($fe),y
		iny
		cpy lengt
		bne cllp2
rtclr	rts

;--------------------------------------------------------------
diffcal	sec         ;calculate relocate-address difference
		lda newad
		sbc stadd
		sta rdiff
		lda newad+1
		sbc stadd+1
		sta rdiff+1
		rts

;--------------------------------------------------------------
SCRINIT	ldx #$04
		stx $fd
		lda #$d8
		sta $ff
		ldy #0
		sty $fc
		sty $fe

scrlp	lda #$20
vramini	sta ($fc),y
        lda #1
cramini sta ($fe),y
        iny
        bne scrlp
        inc $fd
        inc $ff
		dex
		bne scrlp
        rts

;--------------------------------------------------------------
display ;display data (like Program-counter, command, operand, A,X,Y registers)
		lda swdis
		bne dispnum    ;if display is on, start displaying values
		lda prgcnt+1  ;else just display PC+CMD as $d020 colour
		sta $d020
		rts

dispnum	
		lda prgcnt+1        ;display next coming PC-hi
		jsr hex
		stx $0402
		sty $0403
		lda prgcnt+2        ;display next coming PC-lo
		jsr hex
		stx $0400
		sty $0401
		lda cmdstore   ;display next coming command
		jsr hex
		stx $0405
		sty $0406
		lda cmdstore+1 ;display next coming command's operand byte 1
		jsr hex
		stx $0408
		sty $0409
		lda cmdstore+2 ;display next coming command's operand-byte 2
		jsr hex
		stx $040b
		sty $040c
		lda astore+1   ;display accumulator's actual value
		jsr hex
		stx $0410
		sty $0411
		lda xstore+1   ;display X-register's actual value
		jsr hex
		stx $0413
		sty $0414
		lda ystore+1   ;display Y-register's actual value
		jsr hex
		stx $0416
		sty $0417
scrnon	lda #$1b
		sta $d011
        rts

;---------------------------------------------------------------------

HEX		sta aaa+1
        AND #$0F
        TAY
        LDA HEXTXT,Y
        TAY
aaa		lda #0
        LSR A
        LSR A
        LSR A
        LSR A
        TAX
        LDA HEXTXT,X
        TAX
        RTS


;---------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------
;6510 instruction set-data (0..$FF)

;if $ff, illegal opcode (skipping it yet)

;1st NYBBLE-addressing mode , change only above $80, (last above $c0)
;-----------------------------------------------------------------------
;0-Implied (CLC,TYA,PHP,NOP)    -1 BYTE   ;never change
;1-Accumulator (ASL,ROR)        -1 BYTE   ;never change
;2-Relative (BNE $3456)         -2 BYTES  ;never change

;3-Zeropage (LDA $34)           -2 BYTES  ;never change, but sign zp writing instructions (e.g. STA $FE)
;4-Zeropage,x ( LDA $2A,X )     -2 BYTES  ;never change, but sign zp writing instructions (e.g. STX $a4,y)
;5-Zeropage,y ( LDA $A4,Y )     -2 BYTES  ;never change, but sign zp writing instructions (e.g. STY $ea,x)

;6-Indirect,x (lda ($3a,x) )    -2 BYTES  ;never change, but indicate if points into source range (06 03,FC)
;7-Indirect,y (lda ($4f),y )    -2 BYTES  ;never change, but indicate if points into source range (06 03,FC)

;8-Absolute (LDA $C345,JMP$325A)-3 BYTES  ;always change if inner
;9-Absolute,x (LDA $23D5,X)     -3 BYTES  ;always change if inner
;A-Absolute,y (LDA 123F,Y)      -3 BYTES  ;always change if inner
;B-Indirect   (jmp ($345e) )    -3 BYTES  ;always change if inner, also changes 2 byte long pointer-data

;C-Immediate (LDA #$2B,AND #$3F)-2 BYTES  ;change if affects ptr.

;2nd NYBBLE - if 1, it's a zeropage (pointer)/ zp-indexed STA/STX/STY command, helps you with searching
;------------------------------------------------------------------------------------------------------
CLENGT .BYTE 0,0,1,1,1,1,1,1, 2,2,2,2, 1,0,0,0 ;ADDRESSING MODE LENGTHS (-1)  (0..C categories above)

idata
;------------------------------------------------------------------------
;     iia,inX,?im,inX,0pg,0pg,0pg,0pg .   iia,inX,?im,inX,0pg,0pg,0pg,0pg
;     imp,imm,Aim,imm,abs,abs,abs,abs .   imp,imm,Aim,imm,abs,abs,abs,abs
;     rel,inY,???,inY,0pX,0pX,0pX,0pX .   rel,inY,???,inY,0pX,0pX,0pX,0pX
;     imp,abY,imp,abY,abX,abX,abX,abX .   imp,abY,imp,abY,abX,abX,abX,abX
;-------------------------------------.----------------------------------
.byte $00,$60,$ff,$ff,$ff,$30,$30,$ff ;00-BRK,ORA,jam,slo,nop,ORA,ASL,slo
.byte $00,$C0,$10,$ff,$ff,$80,$80,$ff ;08-PHP,ORA,ASL,anc,nop,ORA,ASL,slo
.byte $20,$70,$ff,$ff,$ff,$40,$40,$ff ;10-BPL,ORA,jam,slo,nop,ORA,ASL,slo
.byte $00,$A0,$ff,$ff,$ff,$90,$90,$ff ;18-CLC,ORA,nop,slo,nop,ORA,ASL,slo

.byte $80,$60,$ff,$ff,$30,$30,$30,$ff ;20-JSR,AND,jam,rla,BIT,AND,ROL,rla
.byte $00,$C0,$10,$ff,$80,$80,$80,$ff ;28-PLP,AND,ROL,anc,BIT,AND,ROL,rla
.byte $20,$70,$ff,$ff,$ff,$40,$40,$ff ;30-BMI,AND,jam,rla,nop,AND,ROL,rla
.byte $00,$A0,$ff,$ff,$ff,$90,$90,$ff ;38-SEC,AND,nop,rla,nop,AND,ROL,rla

.byte $00,$60,$ff,$ff,$ff,$30,$30,$ff ;40-RTI,EOR,jam,sre,nop,EOR,LSR,sre
.byte $00,$C0,$10,$ff,$80,$80,$80,$ff ;48-PHA,EOR,LSR,asr,JMP,EOR,LSR,sre
.byte $20,$70,$ff,$ff,$ff,$40,$40,$ff ;50-BVC,EOR,jam,sre,nop,EOR,LSR,sre
.byte $00,$A0,$ff,$ff,$ff,$90,$90,$ff ;58-CLI,EOR,nop,sre,nop,EOR,LSR,sre

.byte $00,$60,$ff,$ff,$ff,$30,$30,$ff ;60-RTS,ADC,jam,rra,nop,ADC,ROR,rra
.byte $00,$C0,$10,$ff,$B0,$80,$80,$ff ;68-PLA,ADC,ROR,arr,JMP,ADC,ROR,rra
.byte $20,$70,$ff,$ff,$ff,$40,$40,$ff ;70-BVS,ADC,jam,rra,nop,ADC,ROR,rra
.byte $00,$A0,$ff,$ff,$ff,$90,$90,$ff ;78-SEI,ADC,nop,rra,nop,ADC,ROR,rra


.byte $ff,$60,$ff,$ff,$31,$31,$31,$ff ;80-nop,STA,nop.sax,STY.STA,STX,sax
.byte $00,$ff,$00,$ff,$80,$80,$80,$ff ;88-DEY,nop,TXA,ane,STY,STA,STX,sax
.byte $20,$C0,$ff,$ff,$41,$41,$51,$ff ;90-BCC,STA,jam,sha,STY,STA,STX,sax
.byte $00,$A0,$00,$ff,$ff,$90,$ff,$ff ;98-TYA,STA,TXS,shs,shy,STA,shx,sha

.byte $C0,$60,$C0,$ff,$30,$30,$30,$ff ;A0-LDY,LDA,LDX,lax,LDY,LDA,LDX,lax
.byte $00,$C0,$00,$ff,$80,$80,$80,$ff ;A8-TAY,LDA,TAX,lxa,LDY,LDA,LDX,lax
.byte $20,$70,$ff,$ff,$40,$40,$50,$ff ;B0-BCS,LDA,jam,lax,LDY,LDA,LDX,lax
.byte $00,$A0,$00,$ff,$90,$90,$A0,$ff ;B8-CLV,LDA,TSX,lae,LDY,LDA,LDX,lax

.byte $C0,$60,$ff,$ff,$30,$30,$30,$ff ;C0-CPY,CMP,nop,dcp,CPY,CMP,DEC,dcp
.byte $00,$C0,$00,$ff,$80,$80,$80,$ff ;C8-INY,CMP,DEX,sbx,CPY,CMP,DEC,dcp
.byte $20,$70,$ff,$ff,$ff,$40,$40,$ff ;D0-BNE,CMP,jam,dcp,nop,CMP,DEC,dcp
.byte $00,$A0,$ff,$ff,$ff,$90,$90,$ff ;D8-CLD,CMP,nop,dcp,nop,CMP,DEC,dcp

.byte $C0,$60,$ff,$ff,$30,$30,$30,$ff ;E0-CPX,SBC,nop,isb,CPX,SBC,INC,isb
.byte $00,$C0,$00,$ff,$80,$80,$80,$ff ;E8-INX,SBC,NOP,sbc,SBC,CPX,INC,isb
.byte $20,$70,$ff,$ff,$ff,$80,$80,$ff ;F0-BEQ,SBC,jam,isb,nop,SBC,INC,isb
.byte $00,$A0,$ff,$ff,$ff,$90,$90,$ff ;F8-SED,SBC,nop,isb,nop,SBC,INC,isb

;--------------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------------
reltxt .text "SPACE:RELOC...."
findtx .text "FIND!"
HEXTXT .TEXT "0123456789ABCDEF"
;--------------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------------
;databytes calculated by Reloc-aid for further inner calculations - not used by user/coder
;-----------------------------------------------------------------------------------------
endmsk .byte 0    ;if 1, causes stopping maskmaker IRQ, and main prg to jump to relocator
lengt .word $0000 ;=endad-stadd, the length of the area to relocate
rdiff .word $0000 ;=stadd-newad, calculated in 'initnew' subroutine

cmdstore .byte 0,0,0 ;here the actual command + operand are stored

chkptr .word $0000 ;pointer will be used by command/data signer
indiJMP .byte 0    ;sign for indirect JMP ($xxxx) at absolute-addressing handler
outrange .byte 0   ;signs when a call addresses outside the actual source range
selfwr .byte 0     ;this flag is switched on, when the command writes operand of a code. (selfwriting code)
;--------------------------------------------------------------------------------------------------------
